using System;

namespace NewtonRaphson{
	/// <summary>
	/// Metodo para hallar funciones matemticas segn Newton Raphson
	/// </summary>
	class NR{
		[STAThread]
		static void Main(){
			double a=-2,b=2,x=1,h=0.000001,e=0.1; int nmax=10;
			if (NR.Continua(a,b)==1) NR.Raiz(x,h,e,nmax);
			else Console.Write("\nNo tiene raiz");			
			Console.Read();
			return;
		}

		//Funcin para comprobar Teorema de Bolzano
		static int Continua(double a, double b){
			if(((NR.Evaluar(a)<0)&&(NR.Evaluar(b)>0))||((NR.Evaluar(a)>0)&&(NR.Evaluar(b)<0))) 
			return 1;
			else return 0;
		}

		//Funcin para evaluar funcin
		static double Evaluar(double num){
			num=(Math.Pow(num,3))-num+1;
			return num;
		}

		//Funcin para hallar la Raiz
		static void Raiz(double x,double h, double e,int nmax){
			int n=1;
			while((n<nmax)&&((Math.Abs(NR.Evaluar(x)/NR.Prima(x,h)))>=e)){
				x=(x-(NR.Evaluar(x)/NR.Prima(x,h)));
				NR.Evaluar(x);
				if(NR.Evaluar(x)!=0) n++;
			}
			Console.Write("\nSe encontro la raiz en el paso: "+n);
			Console.Write("\nLa raz es: "+x);
			return;
		}

		//Funcin para hallar la Prima
		static double Prima(double x,double h){
			x=((NR.Evaluar((x+h)))-(NR.Evaluar(x)))/h;
			return x;
		}
	}
}
